' jis2sjis.VBS V1.02 (C) yoshioka.teruo@nifty.com 2006-04-04
' jis2sjis.VBS converts character code from JIS to Shift JIS.
' Usage: start jis2sjis.vbs files...
' Usage: CScript.exe //NoLogo jis2sjis.vbs [<input] [>output]

Option Explicit
Dim fso
Dim Path
Dim StdIn
Dim StdOut
Dim tPath
Dim BaseName
Dim n
Dim File
Dim tName
Dim FileName

Set fso=CreateObject("Scripting.FileSystemObject")

For Each Path In WScript.Arguments
  Path=fso.GetAbsolutePathName(Path)
  BaseName=fso.GetBaseName(Path)
  FileName=fso.GetFileName(Path)
  Set StdIn=fso.OpenTextFile(Path)
  tPath=fso.BuildPath(fso.GetParentFolderName(Path),fso.GetTempName())
  Set StdOut=fso.CreateTextFile(tPath)
  n=Process(StdIn,StdOut)
  StdIn.Close
  StdOut.Close

  If Not n Then
    WScript.Echo "Not Converted."
    fso.DeleteFile tPath
    WScript.Quit
  End If
  Set File=fso.GetFile(Path)
  For n=1000 To 1999
    tName=BaseName & "." & Right(n,3)
    Call Rename(File,tName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next
  WScript.Echo FileName & " -> " & tName

  Set File=fso.GetFile(tPath)
  Call Rename(File,FileName)
  If Err<>0  Then
    WScript.Echo Err.Number & ":" & Err.Description
    WScript.Quit
  End If
Next
If WScript.Arguments.Count=0 Then
  If LCase(fso.GetBaseName(WScript.FullName))="cscript" Then
    If Process(WScript.StdIn,WScript.StdOut) Then
      WScript.StdErr.WriteLine "Converted."
    Else
      WScript.StdErr.WriteLine "Not Converted."
    End IF
  Else
    WScript.Echo "Usage: Start jis2sjis.vbs files..."
    WScript.Quit
  End If
End If
WScript.Quit

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

' ESC   0x1B
' KI    0x24 /* '$'             */
' JIS78 0x40 /* '@' 78JIS       */
' JIS83 0x42 /* 'B' 83JIS       */
' KO    0x28 /* '('             */
' ASCII 0x42 /* 'B' ASCII       */
' JJIS  0x4A /* 'J' JIS[} */
' IJIS  0x49 /* 'I' JISJ^Ji */
' HJIS  0x48 /* 'H' p      */

Function Process(StdIn,StdOut)
Dim Line
Dim re
Dim Match
Dim Matches
Dim n 
Dim NL
NL=vbCrLf

Set re=New RegExp
re.Pattern="\x1B\$[@B][^\x1B]*\x1B\([BJIH]"
Do While Not StdIn.AtEndOfStream
  Line=ReadLine(StdIn)
  Do
    Set Matches=re.Execute(Line)
    For Each Match In Matches
      Process=True
      StdOut.Write Left(Line,Match.FirstIndex)
      For n=1+3 To Match.Length-3 Step 2
        StdOut.Write Chr(jis2sjis(Asc(Mid(Match.Value,n,1))*256+Asc(Mid(Match.Value,n+1,1))))
      Next
      Line=Mid(Line,1+Match.FirstIndex+Match.Length)
    Next
  Loop While Matches.Count>0
  StdOut.Write Line
  StdOut.Write NL
Loop
End Function

Function jis2sjis(j)
Dim s
Dim a
Dim b

a=j \ 256
b=j Mod 256
If 33<=a And a<= 94 Then
  If a mod 2 Then
    If 33<=b And b<= 95 Then
      s=a*128+b+28831
    ElseIf 96<=b And b<=126 Then
      s=a*128+b+28832
    Else
      s=0
    End if
  Else
    If 33<=b And b<=126 Then
      s=a*128+b+28798
    Else
      s=0
    End If
  End If
ElseIf 95<=a And a<=126 Then
  If a mod 2 Then
    If 33<=b And b<= 95 Then
      s=a*128+b+45215
    ElseIf 96<=b And b<=126 Then
      s=a*128+b+45216
    Else
      s=0
    End If
  ElseIf 33<=b And b<=126 Then
    s=a*128+b+45182
  Else
    s=0
  End If
Else
  s=0
End If
If s=0 Then
  WScript.Echo "Invalid JIS Code",Right(Hex(256+a),2),Right(Hex(256+b),2)
End If
jis2sjis=s
End Function

Function ReadLine(File)
Dim Line
Dim Char
Do While Not File.AtEndOfStream
  Char=File.Read(1)
  If Char=vbLf Then Exit Do
  Line=Line & Char
Loop
Do While Right(Line,1)=vbCr
  Line=Left(Line,Len(Line)-1)
Loop
ReadLine=Replace(Line,vbNullChar,"")
End Function
