' sjis2jis.VBS V1.02 (C) yoshioka.teruo@nifty.com 2006-04-04
' sjis2jis.VBS converts character code from Shift JIS to JIS. 
' Usage: Start sjis2jis.vbs files...
' Usage: CScript.exe //NoLogo sjis2jis.vbs [<input] [>output]

Dim fso
Dim Path
Dim StdIn
Dim StdOut
Dim tPath
Dim BaseName
Dim n
Dim File
Dim tName
Dim FileName

Set fso=CreateObject("Scripting.FileSystemObject")

For Each Path In WScript.Arguments
  Path=fso.GetAbsolutePathName(Path)
  BaseName=fso.GetBaseName(Path)
  FileName=fso.GetFileName(Path)
  Set StdIn=OpenTextFile(fso,Path)
  tPath=fso.BuildPath(fso.GetParentFolderName(Path),fso.GetTempName())
  Set StdOut=fso.CreateTextFile(tPath)
  n=Process(StdIn,StdOut)
  StdIn.Close
  StdOut.Close

  If Not n Then
    WScript.Echo "Not Converted."
    fso.DeleteFile tPath
    WScript.Quit
  End If
  Set File=fso.GetFile(Path)
  For n=1000 To 1999
    tName=BaseName & "." & Right(n,3)
    Call Rename(File,tName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next
  WScript.Echo FileName & " -> " & tName

  Set File=fso.GetFile(tPath)
  Call Rename(File,FileName)
  If Err<>0  Then
    WScript.Echo Err.Number & ":" & Err.Description
    WScript.Quit
  End If
Next
If WScript.Arguments.Count=0 Then
  If LCase(fso.GetBaseName(WScript.FullName))="cscript" Then
    If Process(WScript.StdIn,WScript.StdOut) Then
      WScript.StdErr.WriteLine "Converted."
    Else
      WScript.StdErr.WriteLine "Not Converted."
    End IF
  Else
    WScript.Echo "Usage: Start sjis2jis.vbs files..."
    WScript.Quit
  End If
End If
WScript.Quit

Function OpenTextFile(fso,File)
Dim fUNICODE
Dim BOM
BOM=fso.OpenTextFile(File).Read(2)
fUNICODE=BOM=Chr(&HFF)&Chr(&HFE) Or BOM=Chr(&HFE)&Chr(&HFF)
Set OpenTextFile=fso.OpenTextFile(file,,,fUNICODE)
End Function

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

' ESC   0x1B
' KI    0x24 /* '$'             */
' JIS78 0x40 /* '@' 78JIS       */
' JIS83 0x42 /* 'B' 83JIS       */
' KO    0x28 /* '('             */
' ASCII 0x42 /* 'B' ASCII       */
' JJIS  0x4A /* 'J' JIS[} */
' IJIS  0x49 /* 'I' JISJ^Ji */
' HJIS  0x48 /* 'H' p      */

Function Process(StdIn,StdOut)
Dim Line
Dim n,i
Dim Char
Dim c,d
Dim isKanji
Dim NL
Dim JIS83
Dim JJIS
Dim SKANA,DKANA,HKANA

NL=vbLF
JIS83=Chr(&H1B) & "$B"
JJIS=Chr(&H1B) & "(J"
SKANA="EBuvAE@BDFHb[ACEGIJLNPRTVXZ\^`cegijklmnqtwz}~JK"
DKANA="KMOQSUWY[]_adfhorux{"
HKANA="psvy|"

Do While Not StdIn.AtEndOfStream
  Line=ReadLine(StdIn)
  isKanji=False
  i=1
  n=Len(Line)
  Do While i<=n
    Char=Mid(Line,i,1)
    c=Asc(Char)
    If c>=160 Then
      If i<n Then
        d=Asc(Mid(Line,i+1,1))
        If d=222 And 182<=c And c<197 Then
          Char=Mid(DKANA,c-182+1,1)
          i=i+1
        ElseIf d=222 And 202<=c And c<207 Then
          Char=Mid(DKANA,c-182-5+1,1)
          i=i+1
        ElseIf d=223 And 202<=c And c<207 Then
          Char=Mid(HKANA,c-202+1,1)
          i=i+1
        Else
          Char=Mid(SKANA,c-160+1,1)
        End IF
      Else
        Char=Mid(SKANA,c-160+1,1)
      End If
    End If
    c=Asc(Char)
    If 0<=c And c<256 Then
      If isKanji Then
        isKanji=False
        StdOut.Write JJIS
      End If
      StdOut.Write Char
    Else
      If Not isKanji Then
        isKanji=True
        Process=True
        StdOut.Write JIS83
      End If
      c=sjis2jis(c)
      StdOut.Write Chr(c \ 256) & Chr(c Mod 256)
    End If
    i=i+1
  Loop
  If isKanji Then
    isKanji=False
    StdOut.Write JJIS
  End If
  StdOut.Write NL
Loop
End Function

Function sjis2jis(s)
Dim j
Dim a
Dim b

If s<0 Then
  s=256*256+s
End If
a=s \ 256
b=s Mod 256
If 129<=a And a<=159 Then
  If 64<=b And b<=126 Then
    j=a*512+b-57631
  ElseIf 128<=b And b<=158 Then
    j=a*512+b-57632
  ElseIf 159<=b And b<=252 Then
    j=a*512+b-57470
  Else
    j=0
  End If
ElseIf 224<=a And a<=239 Then
  If 64<=b And b<=126 Then
    j=a*512+b-90399
  ElseIf 128<=b And b<=158 Then
    j=a*512+b-90400
  ElseIf 159<=b And b<=252 Then
    j=a*512+b-90238
  else
    j=0
  End If
Else
  j=0
End If
If s=0 Then
  WScript.Echo "Invalid Shift JIS Code",Right("0" & Hex(a),2),Right("0" & Hex(b),2)
End If
sjis2jis=j
End Function

Function ReadLine(File)
Dim Line
Dim Char
Do While Not File.AtEndOfStream
  Char=File.Read(1)
  If Char=vbLF Then Exit Do
  Line=Line & Char
Loop
Do While Right(Line,1)=vbCR
  Line=Left(Line,Len(Line)-1)
Loop
ReadLine=Replace(Line,vbNullChar,"")
End Function
